// Class: openfl.filters._ConvolutionFilter.ConvolutionShader

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../../hxClasses_stub").default;
var $import = require("./../../../import_stub").default;
var $extend = require("./../../../extend_stub").default;
function openfl_display_Shader() {return require("./../../../openfl/display/Shader");}

// Constructor

var ConvolutionShader = function() {
	if(this.__glFragmentSource == null) {
		this.__glFragmentSource = "varying vec2 vBlurCoords[9];\n\t\tvarying float vAlpha;\n\t\tvarying vec2 vTexCoord;\n\t\t\n\t\tuniform sampler2D uImage0;\n\t\t\n\t\tuniform float uBias;\n\t\tuniform mat3 uConvoMatrix;\n\t\tuniform float uDivisor;\n\t\tuniform bool uPreserveAlpha;\n\t\t\n\t\tvoid main(void) {\n\t\t\t\n\t\t\tvec4 tc = texture2D (uImage0, vBlurCoords[4]);\n\t\t\tvec4 c = vec4 (0.0);\n\t\t\t\n\t\t\tc += texture2D (uImage0, vBlurCoords[0]) * uConvoMatrix[0][0];\n\t\t\tc += texture2D (uImage0, vBlurCoords[1]) * uConvoMatrix[0][1];\n\t\t\tc += texture2D (uImage0, vBlurCoords[2]) * uConvoMatrix[0][2];\n\t\t\t\n\t\t\tc += texture2D (uImage0, vBlurCoords[3]) * uConvoMatrix[1][0];\n\t\t\tc += tc * uConvoMatrix[1][1];\n\t\t\tc += texture2D (uImage0, vBlurCoords[5]) * uConvoMatrix[1][2];\n\t\t\t\n\t\t\tc += texture2D (uImage0, vBlurCoords[6]) * uConvoMatrix[2][0];\n\t\t\tc += texture2D (uImage0, vBlurCoords[7]) * uConvoMatrix[2][1];\n\t\t\tc += texture2D (uImage0, vBlurCoords[8]) * uConvoMatrix[2][2];\n\t\t\t\n\t\t\tif (uDivisor > 0) {\n\t\t\t\t\n\t\t\t\tc /= vec4 (uDivisor, uDivisor, uDivisor, uDivisor);\n\t\t\t\t\n\t\t\t}\n\t\t\t\n\t\t\tc += vec4 (uBias, uBias, uBias, uBias);\n\t\t\t\n\t\t\tif (uPreserveAlpha) {\n\t\t\t\t\n\t\t\t\tc.a = tc.a;\n\t\t\t\t\n\t\t\t}\n\t\t\t\n\t\t\tgl_FragColor = c * vAlpha;\n\t\t\t\n\t\t}";
	}
	if(this.__glVertexSource == null) {
		this.__glVertexSource = "attribute float aAlpha;\n\t\tattribute vec4 aPosition;\n\t\tattribute vec2 aTexCoord;\n\t\t\n\t\tvarying vec2 vBlurCoords[9];\n\t\tvarying float vAlpha;\n\t\tvarying vec2 vTexCoord;\n\t\t\n\t\tuniform mat4 uMatrix;\n\t\tuniform vec2 uTextureSize;\n\t\t\n\t\tvoid main(void) {\n\t\t\t\n\t\t\tvec2 r = vec2 (1.0, 1.0) / uTextureSize;\n\t\t\tvec2 t = aTexCoord;\n\t\t\t\n\t\t\tvBlurCoords[0] = t + r * vec2 (-1.0, -1.0);\n\t\t\tvBlurCoords[1] = t + r * vec2 (0.0, -1.0);\n\t\t\tvBlurCoords[2] = t + r * vec2 (1.0, -1.0);\n\t\t\t\n\t\t\tvBlurCoords[3] = t + r * vec2 (-1.0, 0.0);\n\t\t\tvBlurCoords[4] = t;\n\t\t\tvBlurCoords[5] = t + r * vec2 (1.0, 0.0);\n\t\t\t\n\t\t\tvBlurCoords[6] = t + r * vec2 (-1.0, 1.0);\n\t\t\tvBlurCoords[7] = t + r * vec2 (0.0, 1.0);\n\t\t\tvBlurCoords[8] = t + r * vec2 (1.0, 1.0);\n\t\t\t\n\t\t\tvAlpha = aAlpha;\n\t\t\tvTexCoord = aTexCoord;\n\t\t\tgl_Position = uMatrix * aPosition;\n\t\t\t\n\t\t}";
	}
	(openfl_display_Shader().default).call(this);
	this.get_data().uDivisor.value = [1];
	this.get_data().uBias.value = [0];
	this.get_data().uPreserveAlpha.value = [true];
}

// Meta

ConvolutionShader.__name__ = ["openfl","filters","_ConvolutionFilter","ConvolutionShader"];
ConvolutionShader.__super__ = (openfl_display_Shader().default);
ConvolutionShader.prototype = $extend((openfl_display_Shader().default).prototype, {
	__update: function() {
		var tmp = this.get_data().uImage0.input.width;
		this.get_data().uTextureSize.value = [tmp,this.get_data().uImage0.input.height];
		(openfl_display_Shader().default).prototype.__update.call(this);
	}
});
ConvolutionShader.prototype.__class__ = $hxClasses["openfl.filters._ConvolutionFilter.ConvolutionShader"] = ConvolutionShader;

// Init



// Statics




// Export

exports.default = ConvolutionShader;